<template>
  <div class="">
    <p class="text-xl font-semibold py-6 px-8 border-b">Pick your locutor</p>
    <div v-if="store.locutors.length != 0" id="locutor-selector" class="">
      <div
        id="locutor-selector-list"
        :class="`overflow-y-scroll ${store.locutor && 'hidden'} md:block scroll-container border-r py-8 px-8 pr-5`"
      >
        <div v-for="locutor in store.locutors" :key="locutor.id" class="locutor-radio mb-4">
          <label
            :for="locutor.id"
            class="bg-slate-300 p-4"
            @click="store.hasSelectedNewLocuter = false"
          >
            <input
              :id="locutor.id"
              v-model="store.selectedLocutorId"
              type="radio"
              name="locutor"
              :value="locutor.id"
            />
            <p class="font-medium text-lg">{{ locutor.name }}</p>
            <p class="font-light">{{ locutor.languages_used.length }} languages</p>
          </label>
        </div>
        <CdxButton
          :action="store.hasSelectedNewLocuter && 'progressive'"
          weight="primary"
          size="large"
          @click="addLocutorButton"
          >Add Locuter</CdxButton
        >
      </div>

      <div
        v-if="store.locutor"
        id="locutor-selector-form"
        :class="`px-8 py-8 ${!store.locutor && 'hidden'} md:block`"
      >
        <p
          class="md:hidden font-light mb-4 cursor-pointer"
          @click="store.selectedLocutorId = undefined"
        >
          <CdxIcon :icon="cdxIconArrowPrevious" />
          Back
        </p>
        <p class="font-medium text-xl mb-3">
          {{ store.locutor.name || 'Add Locuter' }}
        </p>
        <CdxMessage v-if="store.locutor.is_main_locutor" type="notice">
          <p>This locutor is your main locutor.</p>
          <p>It cannot be removed, and you must use it if recording words on your own.</p>
        </CdxMessage>
        <CdxField :disabled="store.locutor.is_main_locutor" :label-icon="cdxIconUserActive">
          <template #label> Name </template>
          <CdxTextInput v-model="store.locutor.name" />
          <template #description> Please enter the locutor's name. </template>
          <template #help-text>
            Note that once this locutor has at least one recording, this name can no longer be
            changed.
          </template>
        </CdxField>

        <!-- date_of_birth -->
        <CdxField :label-icon="cdxIconCalendar">
          <template #label> Year of Birth </template>
          <CdxTextInput
            v-model="store.locutor.year_of_birth"
            input-type="number"
            min="1900"
            :max="new Date().getFullYear()"
          />
          <template #description> Please enter the locutor's year of birth. </template>
        </CdxField>
        <!-- spoken or signed languages -->
        <CdxField :label-icon="cdxIconLanguage">
          <template #label> Spoken or signed languages </template>

          <div class="flex flex-col gap-y-4 my-3 mb-4">
            <div
              v-for="language in store.locutor.languages_used"
              :key="language.language_qid"
              class="flex gap-x-2 w-full items-center"
            >
              <div class="grid grid-cols-3 gap-x-4 w-full">
                <cdx-lookup
                  :key="language.language_qid"
                  v-model:selected="language.language_qid"
                  :initial-input-value="
                    language.language_qid
                      ? languages.find((item) => item.value === language.language_qid)?.label
                      : ''
                  "
                  :menu-items="langaugeItems"
                  aria-label="Lookup default demo"
                  :menu-config="menuConfig"
                  placeholder="Language"
                  @input="languageSearchInput"
                />
                <cdx-select
                  v-model:selected="language.proficiency"
                  :menu-items="proficiencies"
                  default-label="Proficiency"
                />
                <LocationSearch
                  :key="store.selectedLocutorId"
                  v-model="language.place_of_learning"
                  placeholder="Place of learning"
                />
              </div>
              <CdxIcon
                :icon="cdxIconTrash"
                class="cursor-pointer"
                @click="store.removeLanguage(language.language_qid)"
              />
            </div>
          </div>
          <cdxButton action="progressive" weight="primary" @click="store.addLanguage"
            >Add Language</cdxButton
          >
          <!-- <CdxSelect :menu-items="languages" default-label="Select an option" class="w-full" /> -->
        </CdxField>
        <CdxField :label-icon="cdxIconHome">
          <template #label> Place of residence </template>
          <LocationSearch
            :key="store.selectedLocutorId"
            v-model="store.locutor.place_of_residence"
          />
        </CdxField>
        <CdxField :label-icon="cdxIconLogoCC">
          <template #label> License </template>
          <CdxSelect v-model:selected="store.locutor.license" :menu-items="licenses" />
          <template #description>
            License under which future recordings will be released on Wikimedia Commons.
          </template>
        </CdxField>
        <CdxField
          v-if="store.locutor.is_main_locutor === false && store.hasSelectedNewLocuter !== true"
          :disabled="store.locutor.can_be_deleted === false"
        >
          <DeletionDialog
            name-of-the-thing-to-delete="locutor"
            :confirmation-text="store.locutor.name"
            @delete="deleteSelectedLocutor()"
          >
            Delete this locutor
          </DeletionDialog>

          <template #help-text
            >You can only delete locutors that do not have any recordings associated to
            them.</template
          >
        </CdxField>
        <CdxMessage v-if="locutorDeletionError !== ''" type="error" inline fade-in>
          {{ errorMessages[locutorDeletionError] }}
        </CdxMessage>
      </div>
    </div>
    <CdxMessage v-else-if="locutorDataError !== ''" type="error" inline fade-in>
      {{ errorMessages[locutorDataError] }}
    </CdxMessage>
    <div v-else>Loading...</div>
  </div>
</template>

<script setup>
import axios from 'axios'
import { ref, watch } from 'vue'
import {
  CdxField,
  CdxTextInput,
  CdxMessage,
  CdxSelect,
  CdxButton,
  CdxLookup,
  CdxIcon,
} from '@wikimedia/codex'
import {
  cdxIconUserActive,
  cdxIconHome,
  cdxIconLanguage,
  cdxIconLogoCC,
  cdxIconTrash,
  cdxIconArrowPrevious,
  cdxIconCalendar,
} from '@wikimedia/codex-icons'
import { useRecordWizardStore } from '@/stores/recordwizard'
import DeletionDialog from '@/components/DeletionDialog.vue'
import LocationSearch from '@/components/LocationSearch.vue'
import { languages } from '../utils/data'

const emit = defineEmits(['canGoToNextStep', 'canNotGoToNextStep'])

const store = useRecordWizardStore()

const licenses = [
  {
    label: 'Creative Commons Zero',
    value: 'cc-zero',
  },
  {
    label: 'Creative Commons Attribution 4.0',
    value: 'cc-by',
  },
  {
    label: 'Creative Commons Attribution Share-Alike 4.0',
    value: 'cc-by-sa',
  },
]

const proficiencies = [
  {
    label: 'Native',
    value: 5,
  },
  {
    label: 'Good',
    value: 4,
  },
  {
    label: 'Average',
    value: 3,
  },
  {
    label: 'Beginner',
    value: 2,
  },
]

const langaugeItems = ref([])

const menuConfig = {
  boldLabel: true,
}
const checkLocutorFilled = () => {
  if (!store.locutor) return false
  return (
    store.locutor.name.length &&
    store.locutor.languages_used.length &&
    store.locutor.place_of_residence &&
    !store.locutor.languages_used.find((item) => !item.language_qid) &&
    (store.locutor.year_of_birth 
      ? store.locutor.year_of_birth <= new Date().getFullYear() &&
        store.locutor.year_of_birth > 1900
      : true)
  )
}

watch(
  () => (store.selectedLocutorId || store.hasSelectedNewLocuter) && checkLocutorFilled(),
  (newVal) => {
    if (newVal) {
      emit('canGoToNextStep')
    } else {
      emit('canNotGoToNextStep')
    }
  },
)

watch(
  () => store.locutor?.languages_used.length,
  (value) => {
    langaugeItems.value = []
  },
)

function languageSearchInput(value) {
  const alreadySelectedLanguages = store.locutor.languages_used.map((item) => item.language_qid)
  langaugeItems.value = languages
    .filter((langauge) => {
      return !alreadySelectedLanguages.includes(langauge.value)
    })
    .filter((item) => item.label.toLowerCase().includes(value.toLowerCase()))
}

const addLocutorButton = () => {
  store.hasSelectedNewLocuter = true
  store.selectedLocutorId = null
}

const locutorDeletionError = ref('')
const NETWORK_ERROR = 'NETWORK_ERROR'
const NOT_AUTHENTICATED = 'NOT_AUTHENTICATED'
const UNEXPECTED_ERROR = 'UNEXPECTED_ERROR'
const CANNOT_DELETE_LOCUTOR = 'CANNOT_DELETE_LOCUTOR'
const CANNOT_FIND_LOCUTOR_TO_DELETE = 'CANNOT_FIND_LOCUTOR_TO_DELETE'
const errorMessages = {
  NETWORK_ERROR:
    "Could not reach Lingua Libre's server. Either it is currently unavailable, or your internet connection is unstable. Please try again in a few minutes.",
  NOT_AUTHENTICATED:
    'An issue occurred when authenticating the request. Please logout and login again.',
  UNEXPECTED_ERROR:
    "An unexpected error occurred. Please contact the site's administrator and provide the error log from the console.",
  CANNOT_DELETE_LOCUTOR: 'You cannot delete this Locutor.',
  CANNOT_FIND_LOCUTOR_TO_DELETE:
    'Oops! How could you even ask for this non-existent Locutor to be deleted?',
}

const locutorDataError = ref('')

// query locutors only if there are none in the store
if (store.locutors.length === 0) {
  axios
    .get('/locutors/my', { withCredentials: true })
    .then((response) => response.data)
    .then((response) => (store.locutors = response))
    .catch((error) => {
      if (error.response) {
        // 403 Not Authenticated (maybe could happen if the session cookie is expired?)
        if (error.response.status === axios.HttpStatusCode.Forbidden)
          locutorDataError.value = NOT_AUTHENTICATED
        // Unexpected error
        else {
          locutorDataError.value = UNEXPECTED_ERROR
          console.log(error.response)
        }
      } else if (error.request) {
        // Could not get a response, probably a network error
        locutorDataError.value = NETWORK_ERROR
      }
    })
}

function deleteSelectedLocutor() {
  const requestConfig = {
    withCredentials: true,
    withXSRFToken: true,
  }

  axios
    .delete('/locutors/my/' + store.locutor.id, requestConfig)
    .then(() => {
      // successful deletion
      store.removeSelectedLocutor()
    })
    .catch((error) => {
      if (error.response) {
        // 400 Cannot delete (the front should prevent such a request to be sent, but better safe than sorry!)
        if (error.response.status === axios.HttpStatusCode.BadRequest)
          locutorDeletionError.value = CANNOT_DELETE_LOCUTOR
        // 403 Not Authenticated (same, should technically never happen, but you never know)
        else if (error.response.status === axios.HttpStatusCode.Forbidden)
          locutorDeletionError.value = NOT_AUTHENTICATED
        // 404 Not Found (same, should technically never happen)
        else if (error.response.status === axios.HttpStatusCode.NotFound)
          locutorDeletionError.value = CANNOT_FIND_LOCUTOR_TO_DELETE
        // Unexpected error
        else {
          locutorDeletionError.value = UNEXPECTED_ERROR
          console.log(error.response)
        }
      } else if (error.request) {
        // Could not get a response, probably a network error
        locutorDeletionError.value = NETWORK_ERROR
      }
    })
}
</script>

<style>
.cdx-text-input,
.cdx-select-vue__handle {
  min-width: unset;
}
#locutor-selector {
  display: flex;
  flex-direction: row;
}

.cdx-field {
  margin-bottom: 1rem;
}

#locutor-selector-list {
  flex: 2;
  max-height: 800px;
}

#locutor-selector-form {
  flex: 7;
}

.locutor-radio input[type='radio'] {
  display: none;
}
.locutor-radio label {
  display: block;
  border-radius: 6px;
  cursor: pointer;
  overflow-wrap: break-word;
  hyphens: auto;
}

.locutor-radio label:has(input:checked) {
  background-color: #3366cc;
  color: white;
}
</style>
